:: This program edits comments in a zip file.
:: Usage: zip4cmnt zipfile [files]
:: If no files are specified all files will be edited.

:: Thanks to Bill Budney for this contribution.

:: Note: to clear a comment delete all characters after the file name.

@echo off
setlocal

:: Calculate file age in seconds
alias myfileage=`set secs=%@eval[%@date[%@filedate[%1]]*3600*24+%@time[%@filetime[%1]]]`

:: UnZip4 switches (-s-...):
:: Extract comments to Descript.$z4 (c). Do it Quietly (q).
echo Extracting zip file comments to Descript.$z4...
unzip4 %& -s-cq
if %? != 0 goto exit

:: Find time of comment file before editing
myfileage descript.$z4
set oldfiletime=%secs

:: Find current time in minutes since midnight before editing comments
set minute=%@int[%@eval[%@time[%_time]/60]]

:: SUBSTITUTE YOUR FAVORITE EDITOR FOR "EDIT"
edit descript.$z4

:: Right away, find how many minutes have ticked while in the editor.
set minute=%@eval[%minute - %@int[%@eval[%@time[%_time]/60]]]

:: Re-insert the comments into the zip file if they changed.
myfileage descript.$z4
iff %oldfiletime == %secs then
  :: It appears that the comments weren't changed. But we can't be sure
  :: because time only resolves to the minute.
  :: See if we were editing long enough for the minute to change.
  iff %minute eq 0 then
    beep

text



You spent less than 1 minute editing zip file comments. I can't tell if
you changed them. Do you want to update the zip file comments? (Y/n)
endtext

    set ans=Y
    INKEY %%ans
    if "%ans"=="Y" goto modify
  endiff

text    


Zip file comments were not changed.


endtext
  goto exit
endiff

:modify
text


Modifying zip file comments...


endtext

:: Re-insert the comments
zip4 %& -s-cq


:exit
if exist descript.$z4 del /q descript.$z4

